## python-pegen 0.3.0

=== Makefile ===
PYTHON ?= python
PIP_INSTALL=$(PYTHON) -m pip install
DOCSBUILDDIR := docs/_build
HTMLDIR := $(DOCSBUILDDIR)/html

# Use this to inject arbitrary commands before the make targets (e.g. docker)
ENV :=

.PHONY: dist
dist:  ## Generate Python distribution files
	$(PYTHON) -m pep517.build .

.PHONY: install-sdist
install-sdist: dist  ## Install from source distribution
	$(ENV) $(PIP_INSTALL) $(wildcard dist/*.tar.gz)

.PHONY: install
test-install:  ## Install with test dependencies
	$(ENV) $(PIP_INSTALL) -e .[test]

.PHONY: test
check:  ## Run the test suite
	$(PYTHON) -m pytest -vvv --log-cli-level=info -s --color=yes $(PYTEST_ARGS) tests

.PHONY: pycoverage
pycoverage:  ## Run the test suite, with Python code coverage
	$(PYTHON) -m pytest \
		-vvv \
		--log-cli-level=info \
		-s \
		--color=yes \
		--cov=pegen \
		--cov-config=tox.ini \
		--cov-report=term \
		--cov-append $(PYTEST_ARGS) \
		tests

.PHONY: format
format: ## Format all files
	$(PYTHON) -m black src tests

.PHONY: lint
lint: ## Lint all files
	$(PYTHON) -m black --check src tests
	$(PYTHON) -m flake8 src tests
	$(PYTHON) -m mypy src/pegen

.PHONY: clean
clean:  ## Clean any built/generated artifacts
	find . | grep -E '(\.o|\.so|\.gcda|\.gcno|\.gcov\.json\.gz)' | xargs rm -rf
	find . | grep -E '(__pycache__|\.pyc|\.pyo)' | xargs rm -rf

.PHONY: regen-metaparser
regen-metaparser: src/pegen/metagrammar.gram src/pegen/*.py # Regenerate the metaparser
	$(PYTHON) -m pegen -q src/pegen/metagrammar.gram -o src/pegen/grammar_parser.py
	$(PYTHON) -m black src/pegen/grammar_parser.py

.PHONY: docs
docs:  ## Generate documentation
	$(MAKE) -C docs clean
	$(MAKE) -C docs html

.PHONY: gh-pages
gh-pages:  ## Publish documentation on BBGitHub Pages
	$(eval GIT_REMOTE := $(shell git remote get-url $(UPSTREAM_GIT_REMOTE)))
	$(eval COMMIT_HASH := $(shell git rev-parse HEAD))
	touch $(HTMLDIR)/.nojekyll
	@echo -n "Documentation ready, push to $(GIT_REMOTE)? [Y/n] " && read ans && [ $${ans:-Y} == Y ]
	git init $(HTMLDIR)
	GIT_DIR=$(HTMLDIR)/.git GIT_WORK_TREE=$(HTMLDIR) git add -A
	GIT_DIR=$(HTMLDIR)/.git git commit -m "Documentation for commit $(COMMIT_HASH)"
	GIT_DIR=$(HTMLDIR)/.git git push $(GIT_REMOTE) HEAD:gh-pages --force
	rm -rf $(HTMLDIR)/.git

.PHONY: help
help:  ## Print this message
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

demo:
	PYTHONPATH=$(shell pwd)/src:$(PYTHONPATH) $(PYTHON) -m pegen data/python.gram -o data/python_parser.py
	PYTHONPATH=$(shell pwd)/src:$(PYTHONPATH) $(PYTHON) data/python_parser.py -r tests/demo.py

=== debian/changelog ===
python-pegen (0.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1099623)

 -- Alexander Sulfrian <alexander@sulfrian.net>  Wed, 02 Jul 2025 17:24:28 +0200

=== debian/control ===
Source: python-pegen
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Alexander Sulfrian <alexander@sulfrian.net>
Build-Depends:
  debhelper-compat (= 13),
  dh-python,
  dh-sequence-sphinxdoc <!nodoc>,
  furo <!nodoc>,
  jdupes <!nodoc>,
  pybuild-plugin-pyproject,
  python3-all,
  python3-pytest <!nocheck>,
  python3-pytest-cov <!nocheck>,
  python3-setuptools (>= 61.2),
  python3-setuptools-scm (>= 3.4.3),
  python3-sphinx <!nodoc>,
  python3-sphinx-copybutton <!nodoc>,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-pegen
Vcs-Git: https://salsa.debian.org/python-team/packages/python-pegen.git
Homepage: https://github.com/we-like-parsers/pegen/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild

Package: python3-pegen
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: CPython's PEG parser generator
 Pegen is the parser generator used in CPython to produce the parser used by
 the interpreter. It allows one to produce PEG parsers from a description of a
 formal Grammar.
 .
 Pegen exists to distribute a version of the Python PEG parser generator used
 by CPython that can be installed as package, with some improvements. Although
 the official PEG generator included in CPython can generate both Python and C
 code, this distribution of the generator only allows one to generate Python
 code. This is due to the fact that the C code generated by the generator
 included in CPython includes a lot of implementation details and private
 headers that are not available for general usage.
 .
 This package contains the Python 3 version of Pegen.

Package: python-pegen-doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Built-Using: ${sphinxdoc:Built-Using}
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: CPython's PEG parser generator (documentation)
 Pegen is the parser generator used in CPython to produce the parser used by
 the interpreter. It allows one to produce PEG parsers from a description of a
 formal Grammar.
 .
 Pegen exists to distribute a version of the Python PEG parser generator used
 by CPython that can be installed as package, with some improvements. Although
 the official PEG generator included in CPython can generate both Python and C
 code, this distribution of the generator only allows one to generate Python
 code. This is due to the fact that the C code generated by the generator
 included in CPython includes a lot of implementation details and private
 headers that are not available for general usage.
 .
 This package contains the documentation for Pegen.

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-

export PYBUILD_NAME=pegen
export PYBUILD_TEST_PYTEST=1

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	http_proxy='http://127.0.0.1:9/' PYTHONPATH=. python3 -m sphinx -N -bhtml docs/ debian/python-pegen-doc/usr/share/doc/python-pegen-doc/html/
	dh_sphinxdoc
endif

override_dh_link:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	jdupes -rl debian/python-pegen-doc/usr/share/doc/python-pegen-doc/html/
endif
	dh_link

=== debian/watch ===
version=4
https://github.com/we-like-parsers/pegen/tags .*/v(\d.*)@ARCHIVE_EXT@
